program Find;
	const Min = 1;
	const Max = 10;
	type Vector = array[Min..Max] of integer;

	var guess : integer;

	function CreateVector() : Vector;
		var v : Vector;
		begin
			v[1] := 27;	v[2] := 29;	v[3] := 38;	v[4] := 42;	v[5] := 43;
			v[6] := 47;	v[7] := 54;	v[8] := 59;	v[9] := 60; v[10] := 62;

			CreateVector := v;
		end;

	function Exists(min, max, search : integer; v : Vector) : boolean;
		var middle : integer;
		begin

			(* Found *)
			if (search = v[min]) or (search = v[max]) then
				Exists := true

			(* Not found *)
			else if max - min < 2 then
				Exists := false

			(* Keep looking *)
			else begin
				middle := min + Trunc((max - min) / 2);

				if (search >= v[middle]) then
					Exists := Exists(middle, max, search, v)
				else
					Exists := Exists(min, middle - 1, search, v);			
			end;
		end;

	(* Main program starts here *)
	begin
		Write('Test if a number is in vector: ');
		Readln(guess);

		Writeln(Exists(Min, Max, guess, CreateVector()));
	end.
